"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const fs = require('fs');
const path = require('path');
const BOT_CONF = 'bot-genned.json';
exports.merge = (relPath, gennedFileName) => {
    let dir = path.resolve(process.cwd(), relPath);
    if (!fs.existsSync(dir))
        return;
    debugger;
    let parts = {};
    readFiles(relPath, parts);
    let botConf = parts['config'];
    if (!botConf)
        throw new Error(`No "config.json" found in ${dir}`);
    let enabled = parts.products;
    if (enabled)
        botConf.products.enabled = enabled;
    let tours = parts.tours;
    if (tours)
        botConf.tours = tours;
    for (let p in parts)
        fillPart(parts[p], parts);
    fillPart(botConf, parts);
    fs.writeFileSync(gennedFileName, JSON.stringify(botConf, null, 2));
};
function fillPart(part, parts) {
    for (let p in part) {
        if (typeof part[p] === 'object') {
            fillPart(part[p], parts);
            continue;
        }
        if (typeof part[p] !== 'string' || !part[p].startsWith('__'))
            continue;
        let val = part[p].slice(2);
        if (!parts[val])
            throw new Error(`No "${val}" found to substitute for "${p}"`);
        part[p] = parts[val];
    }
}
function readFiles(dir, parts) {
    let fullpath = path.resolve(process.cwd(), dir);
    let files = fs.readdirSync(fullpath, { encoding: 'utf8' });
    if (!files.length)
        return;
    files.forEach(f => {
        if (fs.lstatSync(`${fullpath}/${f}`).isDirectory())
            readFiles(`${dir}/${f}`, parts);
        let [name, extension] = f.split('.');
        if (extension && extension === 'json' || extension === 'js')
            parts[name] = require(path.resolve(dir, f));
    });
}
//# sourceMappingURL=merge.js.map